#include <Modules/display.h>

char*
display_options[] = {
	"framerate",
	"desks",
	"edge-flip",
	"edge-flip-timeout",
	"cursor-size",
	"use-e-cursor",
	"cursor-size"/*,
	"default-engine"*/
};

char*
_help_text[] = {
	"",
	"Set the number of virtual desktops (X x Y) <br> ",
	"Switch desktop if mouse touches screen-edge <br> ",
	"",
	"Use skinned mouse-cursor of chosen theme or X-default",
	""/*,
	""*/
};

void
display_desks(Etk_Object *object, void* data) {
	Desks_setting *ds = data;
	Etk_Widget *button = ETK_WIDGET(object);

	char	setting[6],
			*tmp;
	
	int x = atoi(etk_label_get(ETK_LABEL(ds->label_x)));
	int y = atoi(etk_label_get(ETK_LABEL(ds->label_y)));
	
	if (button == ds->button_x_add)
		x++;
	else if (button == ds->button_x_sub)
		x--;
	else if (button == ds->button_y_add)
		y++;
	else if (button == ds->button_y_sub)
		y--;
	else
		return;
	sprintf(setting,"%d %d",x,y);
	setOption("desks",setting);
	tmp = getSetting("desks");
	etk_label_set(ETK_LABEL(ds->label_x),strtok(tmp," "));
	etk_label_set(ETK_LABEL(ds->label_y),strtok(NULL," "));
}

Etk_Widget*
init_display(){
	Etk_Widget *window,*table,*o_table;
	Setting_with_entry *swe;
	Desks_setting *ds;
	char *setting;
	int i = 0;
	
	window = etk_window_new();
	etk_window_title_set(ETK_WINDOW(window),"Display Settings");
	etk_signal_connect_after("destroy",ETK_OBJECT(window),ETK_CALLBACK(sub_window_kill),NULL);
	
	table = etk_table_new(2,10,FALSE);
	etk_container_add(ETK_CONTAINER(window),table);

	//framerate	
	o_table = etk_table_new(3,1,FALSE);
	swe = new_setting_with_entry("Framerate:",display_options[0],_help_text[0]);
	add_to_root_table_swe(table,swe,i*2);
	
	//desktops
	o_table = etk_hbox_new(FALSE,0);
	ds = (Desks_setting *) malloc(sizeof(Desks_setting));
	setting = getSetting(display_options[1]);
	//set ds
	ds->label_x = etk_label_new(strtok(setting," "));
	ds->label_y = etk_label_new(strtok(NULL," "));
	ds->button_x_add = etk_button_new_with_label("+");
	etk_widget_size_request_set(ds->button_x_add,32,32);
	etk_signal_connect("clicked",ETK_OBJECT(ds->button_x_add),ETK_CALLBACK(display_desks),ds);
	ds->button_y_add = etk_button_new_with_label("+");
	etk_widget_size_request_set(ds->button_y_add,32,32);
	etk_signal_connect("clicked",ETK_OBJECT(ds->button_y_add),ETK_CALLBACK(display_desks),ds);
	ds->button_x_sub = etk_button_new_with_label("-");
	etk_widget_size_request_set(ds->button_x_sub,32,32);
	etk_signal_connect("clicked",ETK_OBJECT(ds->button_x_sub),ETK_CALLBACK(display_desks),ds);
	ds->button_y_sub = etk_button_new_with_label("-");
	etk_widget_size_request_set(ds->button_y_sub,32,32);
	etk_signal_connect("clicked",ETK_OBJECT(ds->button_y_sub),ETK_CALLBACK(display_desks),ds);
	//fill hbox
	etk_box_pack_start(ETK_BOX(o_table),ds->button_x_sub,FALSE,FALSE,1);
	etk_box_pack_start(ETK_BOX(o_table),ds->label_x,FALSE,FALSE,1);
	etk_box_pack_start(ETK_BOX(o_table),ds->button_x_add,FALSE,FALSE,1);
	etk_box_pack_start(ETK_BOX(o_table),etk_label_new(" X "),FALSE,FALSE,3);
	etk_box_pack_start(ETK_BOX(o_table),ds->button_y_sub,FALSE,FALSE,1);
	etk_box_pack_start(ETK_BOX(o_table),ds->label_y,FALSE,FALSE,1);
	etk_box_pack_start(ETK_BOX(o_table),ds->button_y_add,FALSE,FALSE,1);
	//add to root-table
	i++;
	add_to_root_table( table, "Desktops", _help_text[i], o_table, i*2 );
	
	//edgeflip
	o_table = etk_table_new(1,1,FALSE);
	etk_table_attach(ETK_TABLE(o_table),get_prepared_toggle_button(display_options[2])
		,0,0,0,0,0,0,ETK_FILL_POLICY_NONE);
	i++;
	add_to_root_table( table, "Edge Flip", _help_text[i], o_table ,i*2);
	i++;
	add_to_root_table_swe(	table,
							new_setting_with_entry(	"Edge Flip Delay",
													display_options[3],
													_help_text[3]),
							i*2 );
	//cursor-size
	o_table = etk_hbox_new(FALSE,0);
	etk_box_pack_start(ETK_BOX(o_table),get_prepared_toggle_button(display_options[5]),FALSE,FALSE,0);
	i++;
	add_to_root_table(table,"Use E-Pointer", _help_text[i], o_table,i*2);
	i++;
	add_to_root_table_swb(table,new_setting_with_buttons("Mouse-pointer-size:",display_options[6], _help_text[i],1,8), i*2);
	
	etk_widget_show_all(window);
	return window;
}
