#include <main.h>
#include <Modules/modules.h>
#include <Modules/display.h>
#include <Modules/menu.h>
#include <Modules/window.h>
#include <Modules/winlist.h>
#include <Modules/focus.h>

#define cout stdout

Setting_with_entry *
new_setting_with_entry(	char *label, char *e_switch, char *help_text ) {
	Setting_with_entry * _new = (Setting_with_entry *) malloc(sizeof(Setting_with_entry));

	_new->setting_label = etk_label_new(getSetting(e_switch));
	_new->entry = etk_entry_new();
	_new->button = etk_button_new_with_label("SET");

	_new->e_switch = (char*)malloc(strlen(e_switch)+1);
	strcpy(_new->e_switch,e_switch);
	_new->label = (char *) malloc(strlen(label)+1);
	strcpy(_new->label,label);
	_new->help_text = help_text;

	etk_signal_connect("clicked",ETK_OBJECT(_new->button),ETK_CALLBACK(setting_swe),_new);
	return _new;
}

Setting_with_buttons *
new_setting_with_buttons(char *label, char *e_switch, char *help_text, double diff, double min){
	Setting_with_buttons *_new = (Setting_with_buttons *) malloc(sizeof(Setting_with_buttons));

	_new->setting_label = etk_label_new(getSetting(e_switch));

	_new->button_add = etk_button_new_with_label("+");
	etk_widget_size_request_set(_new->button_add,32,32);
	etk_signal_connect("clicked",ETK_OBJECT(_new->button_add),ETK_CALLBACK(setting_swb),_new);
	_new->button_substract = etk_button_new_with_label("-");
	etk_widget_size_request_set(_new->button_substract,32,32);
	etk_signal_connect("clicked",ETK_OBJECT(_new->button_substract),ETK_CALLBACK(setting_swb),_new);

	_new->e_switch = (char*)malloc(strlen(e_switch)+1);
	strcpy(_new->e_switch,e_switch);
	_new->label = (char *) malloc(strlen(label)+1);
	strcpy(_new->label,label);
	_new->help_text = help_text;

	_new->minimum = 0;
	_new->difference = diff;
	_new->minimum = min;

	return _new;
}

char*
getSetting(char* option){
	char* command = get_raw_command();
	char* ret = (char*)malloc(512);
	ret[0] = 0;

	strcat(command,option);
	strcat(command,"-get");
	
	FILE *op = popen(command,"r");
	fgets(ret,512,op);
	fgets(ret,512,op);
	ret[strlen(ret)-1] = 0;
	return ret+7;
}

int
setOption(char *option, const char *setting){
	int ret;
	char* command = get_raw_command();
	strcat(command,option);
	strcat(command,"-set ");
	strcat(command,setting);
	if ((ret = system(command)))
		printf("Error on executing `%s`",command);
	else
		return TRUE;
	return ret;
}

void
endit(void *data){
	if (_openWindow != NULL){
		modules_initialized = FALSE;
		etk_object_destroy(ETK_OBJECT(_openWindow));
		_openWindow = NULL;
	}
	etk_main_quit();
}

void
setting_switch(Etk_Object *object, void *data){
	Etk_Toggle_Button *button = ETK_TOGGLE_BUTTON(object);
	if (button->active){
		etk_button_label_set(ETK_BUTTON(button),"disabled");
		setOption(data,"0");
	} else {
		etk_button_label_set(ETK_BUTTON(button),"enabled");
		setOption(data,"1");
	}
}

void
setting_swe(Etk_Object *object, void *data){
	Setting_with_entry *swe = data;

	const char* setting = etk_entry_text_get(ETK_ENTRY(swe->entry));
	if (!setting)
		return;
	setOption(swe->e_switch,setting);
	etk_label_set(ETK_LABEL(swe->setting_label),getSetting(swe->e_switch));
}

void
setting_swb(Etk_Object *object, void *data){
	Setting_with_buttons *swb = data;
	Etk_Label *label = ETK_LABEL(swb->setting_label);
	char newset[64];
	const char *_label = etk_label_get(label);
	double i;
	for (;_label[0]!=0;_label++){
		if (_label[0] > 47 && _label[0] < 58)
			break;
	}
	if (_label[0] == 0)
		return;
	i = atof(_label);
	if (etk_button_label_get(ETK_BUTTON(object))[0] == '+')
		i += swb->difference;
	else if (i > swb->minimum)
		i -= swb->difference;
	else
		return;
	sprintf(newset,"%f",i);
	setOption(swb->e_switch,newset);
	etk_label_set(label,getSetting(swb->e_switch));
}

void
sub_window_kill (){
	_openWindow = NULL;
}

void
clicked(void *data){
	Etk_Widget *tb = data;
	if (_openWindow != NULL){
		modules_initialized = FALSE;
		etk_object_destroy(ETK_OBJECT(_openWindow));
		_openWindow = NULL;
	}
	if (tb == _modules){
		_openWindow = init_modules();
	} else if (tb == _display) {
		_openWindow = init_display();
	} else if (tb == _menu) {
		_openWindow = init_menu();
	} else if (tb == _windows) {
		_openWindow = init_window();
	} else if (tb == _winlist) {
		_openWindow = init_winlist();
	} else if (tb == _focus) {
		_openWindow = init_focus();
	} else {
		fputs("Huh? where did this come from?\n",cout);
	}
}

char*
get_raw_command(){
	_raw_command[0] = 0;
	strcat(_raw_command,"enlightenment_remote -");
	return _raw_command;
}

Etk_Widget*
get_prepared_toggle_button(char *option){
	Etk_Widget *button = etk_toggle_button_new_with_label("enabled");
	char* setting = getSetting(option);
	if (!strcmp(setting,"1") || !strcmp(setting,"POLICY=1"))
		etk_toggle_button_active_set(ETK_TOGGLE_BUTTON(button),TRUE);
	else {
		etk_toggle_button_active_set(ETK_TOGGLE_BUTTON(button),FALSE);
		etk_button_label_set(ETK_BUTTON(button),"disabled");
	}
	etk_signal_connect("pressed",ETK_OBJECT(button),ETK_CALLBACK(setting_switch),option);
	return button;
}

int
add_to_root_table(Etk_Widget* table, const char* label, const char* help, Etk_Widget* content, int row){
	if (!table || !label || !content)
		return -1;
	char label_new[strlen(label)+35];
	sprintf(label_new,"<+ font_size=15 align=center > %s ",label);
	etk_table_attach_defaults(ETK_TABLE(table),etk_label_new(label_new),0,0,row,row);
	etk_table_attach_defaults(ETK_TABLE(table),content,1,1,row,row);
	if (help && strlen(help) > 0)
		etk_table_attach_defaults(ETK_TABLE(table),etk_label_new(help),0,1,row+1,row+1);
	return row;
}

int
add_to_root_table_swe(Etk_Widget* table, Setting_with_entry *setting, int row){
	Etk_Widget *container = etk_hbox_new(FALSE,2);
	etk_box_pack_start(ETK_BOX(container),setting->setting_label,FALSE,FALSE,0);
	etk_box_pack_end(ETK_BOX(container),setting->button,FALSE,FALSE,0);
	etk_box_pack_end(ETK_BOX(container),setting->entry,FALSE,FALSE,0);
	return add_to_root_table(table,setting->label,setting->help_text,container,row);
}

int
add_to_root_table_swb(Etk_Widget *table, Setting_with_buttons *setting, int row){
	Etk_Box *container = ETK_BOX(etk_hbox_new(FALSE,2));
	etk_box_pack_start(container,setting->button_substract,0,0,0);
	etk_box_pack_start(container,setting->setting_label,0,0,0);
	etk_box_pack_start(container,setting->button_add,0,0,0);
	return add_to_root_table(table,setting->label,setting->help_text,ETK_WIDGET(container),row);
}

int
main (int argc, char* args[]){
	Etk_Widget *window, *table;
	int indexX = 0,indexY = 0;
	_raw_command = (char*)malloc(512);
	etk_init();
	
	window = etk_window_new();
	etk_window_title_set(ETK_WINDOW(window),"eConfig by VVeIrD");
	//etk_widget_size_request_set(window,150,270);
	etk_signal_connect_after("destroy",ETK_OBJECT(window),ETK_CALLBACK(endit),NULL);
	
	table = etk_table_new(3,2,TRUE);
	etk_container_add(ETK_CONTAINER(window),table);
	
	_modules = etk_button_new_with_label("Modules");
	etk_signal_connect("clicked",ETK_OBJECT(_modules),ETK_CALLBACK(clicked),_modules);
	etk_table_attach_defaults(ETK_TABLE(table),_modules,indexX,indexX,indexY,indexY);
	indexX++;
	
	_display	= etk_button_new_with_label("Display");
	etk_signal_connect("clicked",ETK_OBJECT(_display),ETK_CALLBACK(clicked),_display);
	etk_table_attach_defaults(ETK_TABLE(table),_display,indexX,indexX,indexY,indexY);
	indexX++;
		
	_menu		= etk_button_new_with_label("Menu");
	etk_signal_connect("clicked",ETK_OBJECT(_menu),ETK_CALLBACK(clicked),_menu);
	etk_table_attach_defaults(ETK_TABLE(table),_menu,indexX,indexX,indexY,indexY);
	indexX++;
	
	indexX = 0;
	indexY++;
	
	_windows	= etk_button_new_with_label("Windows");
	etk_signal_connect("clicked",ETK_OBJECT(_windows),ETK_CALLBACK(clicked),_windows);
	etk_table_attach_defaults(ETK_TABLE(table),_windows,indexX,indexX,indexY,indexY);
	indexX++;
	
	_winlist	= etk_button_new_with_label("Winlist");
	etk_signal_connect("clicked",ETK_OBJECT(_winlist),ETK_CALLBACK(clicked),_winlist);
	etk_table_attach_defaults(ETK_TABLE(table),_winlist,indexX,indexX,indexY,indexY);
	indexX++;
	
	_focus		= etk_button_new_with_label("Focus");
	etk_signal_connect("clicked",ETK_OBJECT(_focus),ETK_CALLBACK(clicked),_focus);
	etk_table_attach_defaults(ETK_TABLE(table),_focus,indexX,indexX,indexY,indexY);
	indexX++;
	
	etk_widget_show_all(window);
	etk_main();
	etk_shutdown();
	return 0;
}
